import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-react-core";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { PointCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private rq;
    readonly rr: IAnchoredCategorySeriesInteractionManager;
    rm: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    protected bp(): SeriesView;
    kk(a: SeriesView): void;
    ru: boolean;
    constructor();
    r2: string;
    gt(a: any, b: string): any;
    valueColumn: IFastItemColumn$1<number>;
    private rs;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    sk: Brush;
    static readonly r9: DependencyProperty;
    trendLineThickness: number;
    sm: PenLineCap;
    sl: DoubleCollection;
    trendLinePeriod: number;
    rw: number;
    dq(a: any): boolean;
    protected rj(a: number, b: number, c: Axis): any[];
    protected kp(a: any, b: string, c: any, d: any): void;
    ao(a: Axis): AxisRange;
    protected jo(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected qt(): number;
    rv(a: CategorySeriesView): number;
    r7(a: PointCollection, b: number, c: CategorySeriesView): void;
    rk(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    rl(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    ec(a: Rect, b: Rect, c: SeriesView): boolean;
    jl(a: boolean, b: SeriesView): void;
    q9(a: CategoryFrame, b: CategorySeriesView): void;
    rc(a: CategoryFrame, b: CategorySeriesView): void;
    rn: CategoryFrame;
    k2(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    r4(a: CategoryFrame, b: CategorySeriesView): void;
    protected lg(): void;
    gw(a: any, b: Point): any;
    readonly currentCategoryMode: CategoryMode;
    readonly scaler: ICategoryScaler;
    readonly yScaler: IScaler;
    readonly bucketizer: IBucketizer;
    readonly currentMode2Index: number;
    provideCollisionDetector(): IDetectsCollisions;
    readonly trendlinePreparer: IPreparesCategoryTrendline;
    protected ry: string;
    abstract r5(a: Axis): void;
    abstract r6(a: Axis): void;
    protected jv(a: any): void;
    ro: CategorySeriesMarkerCollisionAvoidance;
    gq(a: Point): any;
    rp: ConsolidatedItemHitTestBehavior;
    readonly mayContainUnknowns: boolean;
    fa(): number;
    protected get_rx(): number;
    protected readonly rx: number;
    ap(a: Rect): AxisRange;
    private r8;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c0: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private c1;
    c2: ITrendLineManager;
    readonly c3: boolean;
    c7(): void;
    c5(): void;
    c4(): void;
    cs(): CategoryBucketCalculator;
    c6(): void;
    c8(): void;
    c9(a: number): Rect;
    protected a5(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
